Subject: [IPP] RFC: IPP Paid Printing Extensions

From: Michael Sweet <[email-masked]>
Date: Thu, 14 Mar 2013 18:43:00 -0400

All,

As some of you might have noticed, CUPS 1.7 has support for a new IPP-based paid printing interface.  I have just posted a draft for consideration as future work for the IPP WG at:

    ftp://ftp.pwg.org/pub/pwg/ipp/whitepaper/tb-ipppaid-sweet-20130314.docx
    ftp://ftp.pwg.org/pub/pwg/ipp/whitepaper/tb-ipppaid-sweet-20130314.pdf

This specification expands on what we added (printer-charge-info/-uri) in JPS3 by adding a new job-authorization-uri that is used to authorize a paid printing transaction, much like how credit card transactions are authorized.  As with JPS3, the new interface does not expose the complicated details of currency, but instead focuses on the lower-level transaction processing that is needed.  Section 4 goes into some depth on how it all works, complete with a sequence diagram.

Aside from transactions, this spec also exposes the necessary interfaces for basic quota-based printing (often used in conjunction with transactions) so that the User (and Client software) can know when some action is required of the User.  Like the paid printing interface, the focus is on the lower-level notifications and not on exposing page counts, limits, and the like - I don't feel that the CUPS page count/limit interface is sufficiently generic to be standardized...

I've also thrown in some additional attributes and values that we use in CUPS and other printing standards - print-scaling to control output scaling, new finishings values for punch and fold, and some descriptive attributes providing limits, the default landscape orientation, and information about the Bonjour service name and kind/category of print functions that are supported.  These are not limited to paid printing, but definitely are needed when you get beyond the simple "print this file on plain paper" use cases. Many have also been in use for several years now...  If there is resistance to "bundling" these with the paid printing spec, I am happy to split it out as a separate spec as well.

Enjoy!

_________________________________________________________
Michael Sweet, Senior Printing System Engineer, PWG Chair

-- 
This message has been scanned for viruses and
dangerous content by MailScanner, and is
believed to be clean.

_______________________________________________
ipp mailing list
[email-masked]
https://www.pwg.org/mailman/listinfo/ipp